// --- [ main.c ] -------------------------------------------------------------
//       26.09.2011
//
//       Demonstriert die Anwendung des Moduls DCF_77_mini.c
// ----------------------------------------------------------------------------

#include <avr/io.h>
#include <inttypes.h>
#include <stdlib.h>
#include <string.h>

#include "dcf_77_mini.h"
#include "rs232_mini.h"

char cv[6];							// fr die Umwandlung von Zahlen in Strings

// ----------------------------------------------------------------------------
int main(void)
{
	asm volatile("sei");

	DCF_Init();
	RS232_Init();
	
	put_c(13);
	put_s("Die serielle Schnittstelle funktioniert !");


// Hauptschleife des Projektes, von der aus in die Unterprogramme verzweigt wird.
// Eines davon in DCF_Check_Time().
	while(1)
	{
		if (DCF_New_Second()) // hier die Fortfhrung der Zeit
		{
			DCF_Check_Time();
		
		// zur Demonstration erfolgt hier die Ausgabe der Zeit
		// zunchst werden Werte abgeholt und umgewandelt
			put_c(13);
			put_s(utoa(DCF_Get_Time(STUNDE), cv, 10));
			put_c(':');
			put_s(utoa(DCF_Get_Time(MINUTE), cv, 10));
			put_c(':');
			put_s(utoa(DCF_Get_Time(SEKUNDE), cv, 10));	
			put_c(' ');
			
		// hier werden formatierte Strings abgeholt
			DCF_Get_TimeStr(TAG, cv);
			put_s(cv);
			put_c('.');
			DCF_Get_TimeStr(MONAT, cv);
			put_s(cv);
			put_c('.');
			DCF_Get_TimeStr(JAHR, cv);
			put_s(cv);
	
		// Second of Day und Day of Year knnen bei einem Import von Zeiten
		// in eine Tabellenkalkulation ntzlich sein.
#ifdef SoD
			put_c(' ');	
			put_s(utoa(DCF_Get_SoD(), cv, 10));
#endif
#ifdef DoY
			put_c(' ');	
			put_s(utoa(DCF_Get_DoY(), cv, 10));
#endif		

		}
		
	// if (SonstEtwas()) TuWasSinnvolles;
	
	}
}

// --- [ eof ] ----------------------------------------------------------------
